//+------------------------------------------------------------------+ 
//|                                        4_Level_ZZ_Semafor.mq4    | 
//+------------------------------------------------------------------+ 


#property indicator_chart_window 
#property indicator_buffers 8
#property indicator_color1 Chocolate 
#property indicator_color2 Chocolate 
#property indicator_color3 MediumVioletRed
#property indicator_color4 MediumVioletRed
#property indicator_color5 Orange
#property indicator_color6 Orange
#property indicator_color7 Red
#property indicator_color8 Red

//---- input parameters 
extern double deltaInPips  = 1.0;
extern double Period1=5; 
extern double Period2=13; 
extern double Period3=34; 
extern double Period4=89; 
extern string   Dev_Step_1="0,3"; // For all these Period/Deviation/back-Step values, use whatever works for you. NOTE! Period/Step are in #bars. Deviation is in #pips
extern string   Dev_Step_2="0,5"; 
extern string   Dev_Step_3="0,8"; // Perhaps "13" could be used.
extern string   Dev_Step_4="0,13"; // Perhaps "34"
extern int Symbol_1_Size=0;
extern int Symbol_2_Size=1;
extern int Symbol_3_Size=2;
extern int Symbol_4_Size=3;
int Symbol_1_Kod=140; // These arrow numbers don't need to be "extern" variables.  Change them here in the source if needed.
int Symbol_2_Kod=141;
int Symbol_3_Kod=142;
int Symbol_4_Kod=143;


//---- buffers 
double FP_BuferUp[];
double FP_BuferDn[]; 
double NP_BuferUp[];
double NP_BuferDn[]; 
double HP_BuferUp[];
double HP_BuferDn[]; 
double VP_BuferUp[];
double VP_BuferDn[]; 

int F_Period;
int N_Period;
int H_Period;
int V_Period;
int Dev1;
int Stp1;
int Dev2;
int Stp2;
int Dev3;
int Stp3;
int Dev4;
int Stp4;

double delta;
double myPoint;
//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
   myPoint = getPoint(true);
   delta = deltaInPips*myPoint;
   
// ---------     
   if (Period1>0) F_Period=MathCeil(Period1*Period()); else F_Period=0; 
   if (Period2>0) N_Period=MathCeil(Period2*Period()); else N_Period=0; 
   if (Period3>0) H_Period=MathCeil(Period3*Period()); else H_Period=0; 
   if (Period4>0) V_Period=MathCeil(Period4*Period()); else V_Period=0; 
   
   IndicatorDigits(Digits); 
   
//----  1  
   if (Period1>0)
   {
   SetIndexStyle(0,DRAW_ARROW,0,Symbol_1_Size); 
   SetIndexArrow(0,Symbol_1_Kod); 
   SetIndexBuffer(0,FP_BuferUp); 
   SetIndexEmptyValue(0,0.0); 
   
   SetIndexStyle(1,DRAW_ARROW,0,Symbol_1_Size); 
   SetIndexArrow(1,Symbol_1_Kod); 
   SetIndexBuffer(1,FP_BuferDn); 
   SetIndexEmptyValue(1,0.0); 
   }
   
//----  2  
   if (Period2>0)
   {
   SetIndexStyle(2,DRAW_ARROW,0,Symbol_2_Size); 
   SetIndexArrow(2,Symbol_2_Kod); 
   SetIndexBuffer(2,NP_BuferUp); 
   SetIndexEmptyValue(2,0.0); 
   
   SetIndexStyle(3,DRAW_ARROW,0,Symbol_2_Size); 
   SetIndexArrow(3,Symbol_2_Kod); 
   SetIndexBuffer(3,NP_BuferDn); 
   SetIndexEmptyValue(3,0.0); 
   }
//----  3  
   if (Period3>0)
   {
   SetIndexStyle(4,DRAW_ARROW,0,Symbol_3_Size); 
   SetIndexArrow(4,Symbol_3_Kod); 
   SetIndexBuffer(4,HP_BuferUp); 
   SetIndexEmptyValue(4,0.0); 

   SetIndexStyle(5,DRAW_ARROW,0,Symbol_3_Size); 
   SetIndexArrow(5,Symbol_3_Kod); 
   SetIndexBuffer(5,HP_BuferDn); 
   SetIndexEmptyValue(5,0.0); 
   }
//
   if (Period4>0)
   {
   SetIndexStyle(6,DRAW_ARROW,0,Symbol_4_Size); 
   SetIndexArrow(6,Symbol_4_Kod); 
   SetIndexBuffer(6,VP_BuferUp); 
   SetIndexEmptyValue(6,0.0); 

   SetIndexStyle(7,DRAW_ARROW,0,Symbol_4_Size); 
   SetIndexArrow(7,Symbol_4_Kod); 
   SetIndexBuffer(7,VP_BuferDn); 
   SetIndexEmptyValue(7,0.0); 
   }
//     
   int CDev=0;
   int CSt=0;
   int Mass[]; 
   int C=0;  
   if (IntFromStr(Dev_Step_1,C, Mass)==1) 
      {
        Stp1=Mass[1];
        Dev1=Mass[0];
      }
   
   if (IntFromStr(Dev_Step_2,C, Mass)==1)
      {
        Stp2=Mass[1];
        Dev2=Mass[0];
      }      
   
   
   if (IntFromStr(Dev_Step_3,C, Mass)==1)
      {
        Stp3=Mass[1];
        Dev3=Mass[0];
      }      

   if (IntFromStr(Dev_Step_4,C, Mass)==1)
      {
        Stp4=Mass[1];
        Dev4=Mass[0];
      }      
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custor indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
  { 
//---- 
    
//---- 
   return(0); 
  } 

//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start() 
  { 
   if (Period1>0) CountZZ(FP_BuferUp,FP_BuferDn,Period1,Dev1,Stp1);
   if (Period2>0) CountZZ(NP_BuferUp,NP_BuferDn,Period2,Dev2,Stp2);
   if (Period3>0) CountZZ(HP_BuferUp,HP_BuferDn,Period3,Dev3,Stp3);
   if (Period4>0) CountZZ(VP_BuferUp,VP_BuferDn,Period4,Dev4,Stp4);
      
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//  
//int Take



//+------------------------------------------------------------------+ 
//|                           | 
//+------------------------------------------------------------------+  
int CountZZ( double& ExtMapBufferUp[], double& ExtMapBufferDn[], int ExtDepth, int ExtDeviation, int ExtBackstep )
  {
   int    shift, back,lasthighpos,lastlowpos;
   double val,res;
   double curlow,curhigh,lasthigh,lastlow;

   for(shift=Bars-ExtDepth; shift>=0; shift--)
     {
      val=Low[iLowest(NULL,0,MODE_LOW,ExtDepth,shift)];
      if(val==lastlow) val=0.0;
      else 
        { 
         lastlow=val; 
         if((Low[shift]-val)>(ExtDeviation*myPoint)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBufferUp[shift+back];
               if (res!=0.0) res = res+delta;
               if((res!=0.0)&&(res>val)) ExtMapBufferUp[shift+back]=0.0; 
              }
           }
        } 
        
          if (val==0.0) ExtMapBufferUp[shift] = 0.0;
          else ExtMapBufferUp[shift]=val-delta;
          
      //--- high
      val=High[iHighest(NULL,0,MODE_HIGH,ExtDepth,shift)];
      if(val==lasthigh) val=0.0;
      else 
        {
         lasthigh=val;
         if((val-High[shift])>(ExtDeviation*myPoint)) val=0.0;
         else
           {
            for(back=1; back<=ExtBackstep; back++)
              {
               res=ExtMapBufferDn[shift+back];
               if(res!=0.0) res = res-delta;
               if((res!=0.0)&&(res<val)) ExtMapBufferDn[shift+back]=0.0; 
              } 
           }
        }
      
      if (val==0.0) ExtMapBufferDn[shift] = 0.0;
      else ExtMapBufferDn[shift]=val+delta;
     }
   // final cutting 
   lasthigh=-1; lasthighpos=-1;
   lastlow=-1;  lastlowpos=-1;

   for(shift=Bars-ExtDepth; shift>=0; shift--)
     {
      curlow=ExtMapBufferUp[shift];
      if (curlow != 0.0) curlow = curlow+delta;
      curhigh=ExtMapBufferDn[shift];
      if (curhigh != 0.0) curhigh = curhigh-delta;
      if((curlow==0.0)&&(curhigh==0.0)) continue;
      //---
      if(curhigh!=0.0)
        {
         if(lasthigh>0.0) 
           {
            if(lasthigh<curhigh) ExtMapBufferDn[lasthighpos]=0.0;
            else ExtMapBufferDn[shift]=0.0;
           }
         //---
         if(lasthigh<curhigh || lasthigh<0.0)
           {
            lasthigh=curhigh;
            lasthighpos=shift;
           }
         lastlow=-1;
        }
      //----
      if(curlow!=0.0)
        {
         if(lastlow>0.0)
           {
            if(lastlow>curlow) ExtMapBufferUp[lastlowpos]=0.0;
            else ExtMapBufferUp[shift]=0.0;
           }
         //---
         if((curlow<lastlow)||(lastlow<0.0))
           {
            lastlow=curlow;
            lastlowpos=shift;
           } 
         lasthigh=-1;
        }
     }
  
   for(shift=Bars-1; shift>=0; shift--)
     {
      if(shift>=Bars-ExtDepth) ExtMapBufferUp[shift]=0.0;
      else
        {
         // What??(1) This code was from the original ZigZag.mq4 which used a single buffer for display, hence it copied the BufferDn into the BufferUp, but this 
         // program keeps the buffers separate, so this code is unnecessary, and is replaced by a "break;"
         //
         //res=ExtMapBufferDn[shift];
         //if(res!=0.0) ExtMapBufferUp[shift]=res;
         break;
        }
     }
 }
  
int Str2Massive(string VStr, int& M_Count, int& VMass[])
  {
    int val=StrToInteger( VStr);
    if (val>0)
       {
         M_Count++;
         int mc=ArrayResize(VMass,M_Count);
         if (mc==0)return(-1);
          VMass[M_Count-1]=val;
         return(1);
       }
    else return(0);    
  } 
  
  
int IntFromStr(string ValStr,int& M_Count, int& VMass[])
  {
    
    if (StringLen(ValStr)==0) return(-1);
    string SS=ValStr;
    int NP=0; 
    string CS;
    M_Count=0;
    ArrayResize(VMass,M_Count);
    while (StringLen(SS)>0)
      {
            NP=StringFind(SS,",");
            if (NP>0)
               {
                 CS=StringSubstr(SS,0,NP);
                 SS=StringSubstr(SS,NP+1,StringLen(SS));  
               }
               else
               {
                 if (StringLen(SS)>0)
                    {
                      CS=SS;
                      SS="";
                    }
               }
            if (Str2Massive(CS,M_Count,VMass)==0) 
               {
                 return(-2);
               }
      }
    return(1);    
  }
  
double getPoint(bool custommode)
{
   string symbol = Symbol();
   //double point = Point; // BUG: MT4 Build 392 did NOT update Point/Digits on a NEW CHART until AFTER the init() was done, so avoid and use MarketInfo
   double point = MarketInfo(symbol,MODE_POINT);
   int pluspos = StringFind(symbol,"+",0);
   int minuspos = StringFind(symbol,"-",0);
   if (pluspos > 0) symbol = StringSubstr(symbol,0,pluspos);
   else if (minuspos > 0) symbol = StringSubstr(symbol,0,minuspos);
   if (point < 0.000000001) point = MarketInfo(symbol,MODE_POINT); // try it again without timeshift
   
   if (! custommode) return(point);
   else
   {
      if (symbol == "NOKJPY" || symbol == "SEKJPY" || symbol == "GBPDKK" 
          || symbol == "GBPNOK" || symbol == "USDSKK" || symbol == "XAG") point = MarketInfo(symbol,MODE_POINT); //Point; // These are 0.001 on BroCo.
      else if (StringFind(symbol,"JPY",3) == 3 || symbol == "XAUUSD") point = 0.01; // ***JPY, XAUUSD
      else if (StringFind(symbol,"USD",0) >= 0
               || StringFind(symbol,"EUR",0) >= 0
               || StringFind(symbol,"GBP",0) >= 0
               || StringFind(symbol,"CAD",0) >= 0
               || StringFind(symbol,"NZD",0) >= 0
              ) point = 0.0001;
   }
   if (point < 0.000000001) point = Point;
   if (point < 0.000000001) point = 0.01; // A DEFAULT! Not necessarily a good choice but prevents divide-by-zero problems!
   //Print("getPoint: ",point,"  symbol: ",symbol);
   return(point);
} // end of getPoint

